# Services

- [RPC](https://docs.u2u.xyz/services/rpc.md)
- [RPC Endpoints](https://docs.u2u.xyz/services/rpc/rpc-endpoints.md): A collection of Unicorn Ultra RPC Services
- [Ethereum API Methods](https://docs.u2u.xyz/services/rpc/ethereum-api-methods.md): This section is describing the supported Ethereum RPC method calls of Ultra Unicorn network.
- [eth\_blockNumber](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_blocknumber.md): Returns the number of the most recent block.
- [eth\_call](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_call.md): Executes a new message call immediately without creating a transaction on the block chain.
- [eth\_chainId](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_chainid.md): Returns the currently configured chain ID, a value used in replay-protected transaction signing as introduced by EIP-155.
- [eth\_estimateGas](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_estimategas.md): Generates and returns an estimate of how much gas is necessary to allow the transaction to complete. The transaction will not be added to the blockchain.
- [eth\_feeHistory](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_feehistory.md): Returns a collection of historical gas information
- [eth\_gasPrice](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_gasprice.md): Returns the current price per gas in wei.
- [eth\_getBalance](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getbalance.md): Returns the balance of the account of the given address.
- [eth\_getBlockByHash](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getblockbyhash.md): Returns information about a block by hash.
- [eth\_getBlockByNumber](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getblockbynumber.md): Returns information about a block by block number.
- [eth\_getBlockTransactionCountByHash](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getblocktransactioncountbyhash.md): Returns the number of transactions in a block matching the given block hash.
- [eth\_getBlockTransactionCountByNumber](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getblocktransactioncountbynumber.md): Returns the number of transactions in a block matching the given block number.
- [eth\_getCode](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getcode.md): Returns code at a given address.
- [eth\_getLogs](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getlogs.md): Returns an array of all logs matching a given filter object.
- [eth\_getProof](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getproof.md): Returns the account and storage values of the specified account including the Merkle-proof. This call can be used to verify that the data you are pulling from is not tampered with.
- [eth\_getStorageAt](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getstorageat.md): Returns the value from a storage position at a given address, or in other words, returns the state of the contract's storage, which may not be exposed via the contract's methods.
- [eth\_getTransactionByBlockHashAndIndex](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_gettransactionbyblockhashandindex.md): Returns information about a transaction by block hash and transaction index position.
- [eth\_getTransactionByBlockNumberAndIndex](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_gettransactionbyblocknumberandindex.md): Returns information about a transaction by block number and transaction index position.
- [eth\_getTransactionByHash](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_gettransactionbyhash.md): Returns the information about a transaction requested by transaction hash.
- [eth\_getTransactionCount](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_gettransactioncount.md): Returns the number of transactions sent from an address.
- [eth\_getTransactionReceipt](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_gettransactionreceipt.md): Returns the receipt of a transaction by transaction hash.
- [eth\_getUncleByBlockHashAndIndex](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getunclebyblockhashandindex.md): Returns information about an uncle of a block by hash and uncle index position.
- [eth\_getUncleByBlockNumberAndIndex](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getunclebyblocknumberandindex.md): Returns information about an uncle of a block by number and uncle index position.
- [eth\_getUncleCountByBlockHash](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getunclecountbyblockhash.md): Returns the number of uncles in a block matching the given block hash.
- [eth\_getUncleCountByBlockNumber](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_getunclecountbyblocknumber.md): Returns the number of uncles in a block matching the give block number.
- [eth\_maxPriorityFeePerGas](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_maxpriorityfeepergas.md): Returns a fee per gas that is an estimate of how much you can pay as a priority fee, or "tip", to get a transaction included in the current block.
- [eth\_sendRawTransaction](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_sendrawtransaction.md): Creates new message call transaction or a contract creation for signed transactions.
- [eth\_subscribe](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_subscribe.md): Subscribe to specific events in the blockchain.
- [eth\_unsubscribe](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/eth_unsubscribe.md): Cancel subscriptions.
- [net\_version](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/net_version.md): Returns the current network id.
- [net\_listening](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/net_listening.md): Returns true if client is actively listening for network connections.
- [net\_peerCount](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/net_peercount.md): Returns number of peers currently connected to the client.
- [web3\_clientVersion](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/web3_clientversion.md): Returns the current client version.
- [web3\_sha3](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/web3_sha3.md): Returns Keccak-256 (not the standardized SHA3-256) of the given data.
- [debug\_traceTransaction](https://docs.u2u.xyz/services/rpc/ethereum-api-methods/debug_tracetransaction.md): Attempts to run the transaction in the exact same manner as it was executed on the network. It will replay any transaction that may have been executed prior to this one before it and will then attempt
- [DAG API Methods](https://docs.u2u.xyz/services/rpc/dag-api-methods.md): This section is describing the supported DAG RPC method calls of Ultra Unicorn network.
- [dag\_getEvent](https://docs.u2u.xyz/services/rpc/dag-api-methods/dag_getevent.md): Returns the event (without transactions) by hash or short ID.
- [dag\_getEventPayload](https://docs.u2u.xyz/services/rpc/dag-api-methods/dag_geteventpayload.md): Returns event (including transactions) by hash or short ID
- [dag\_getHeads](https://docs.u2u.xyz/services/rpc/dag-api-methods/dag_getheads.md): Returns IDs of all the epoch events with no descendants in a given epoch
- [eth\_currentEpoch](https://docs.u2u.xyz/services/rpc/dag-api-methods/eth_currentepoch.md): Returns current epoch number
- [eth\_getEpochStats](https://docs.u2u.xyz/services/rpc/dag-api-methods/eth_getepochstats.md): Returns the latest epoch statistics
- [Trace API Methods](https://docs.u2u.xyz/services/rpc/trace-api-methods.md): This section is describing the supported trace RPC method calls of Ultra Unicorn network.
- [trace\_block](https://docs.u2u.xyz/services/rpc/trace-api-methods/trace_block.md): Returns traces created at given block.
- [trace\_get](https://docs.u2u.xyz/services/rpc/trace-api-methods/trace_get.md): Returns trace at given position.
- [trace\_transaction](https://docs.u2u.xyz/services/rpc/trace-api-methods/trace_transaction.md): Returns all traces of given transaction.
- [trace\_filter](https://docs.u2u.xyz/services/rpc/trace-api-methods/trace_filter.md): Returns traces matching given filter.
- [Explorer](https://docs.u2u.xyz/services/explorer.md)
- [Explorer URLs](https://docs.u2u.xyz/services/explorer/explorer-urls.md)
- [Explorer API](https://docs.u2u.xyz/services/explorer/explorer-api.md)
- [Account](https://docs.u2u.xyz/services/explorer/explorer-api/account.md): ?module=account
- [Block](https://docs.u2u.xyz/services/explorer/explorer-api/block.md): ?module=block
- [Contract](https://docs.u2u.xyz/services/explorer/explorer-api/contract.md)
- [Logs](https://docs.u2u.xyz/services/explorer/explorer-api/logs.md): ?module=logs
- [Stats](https://docs.u2u.xyz/services/explorer/explorer-api/stats.md): ?module=stats
- [Token](https://docs.u2u.xyz/services/explorer/explorer-api/token.md): ?module=token
- [Transaction](https://docs.u2u.xyz/services/explorer/explorer-api/transaction.md): ?module=transaction
- [GraphQL](https://docs.u2u.xyz/services/explorer/graphql.md)
- [Explorer RPC API](https://docs.u2u.xyz/services/explorer/explorer-rpc-api.md)
- [Smart Contract Verification](https://docs.u2u.xyz/services/explorer/smart-contract-verification.md): Once verified, a smart contract or token contract's source code becomes publicly available and verifiable. This creates transparency and trust. Plus, it's easy to do!
- [Via explorer](https://docs.u2u.xyz/services/explorer/smart-contract-verification/via-explorer.md): You could directly use U2U Chain blockchain explorer to verify your contract's source code at u2uscan.xyz.
- [Via hardhat plugin](https://docs.u2u.xyz/services/explorer/smart-contract-verification/via-hardhat-plugin.md): Hardhat is a full-featured development environment for contract compilation, deployment and verification. The Hardhat Etherscan plugin supports contract verification on U2U Chain blockchain explorer.
- [Wallets](https://docs.u2u.xyz/services/wallets.md)
- [Metamask](https://docs.u2u.xyz/services/wallets/metamask.md)
- [Wallet Connect](https://docs.u2u.xyz/services/wallets/wallet-connect.md)
- [Coinbase Wallet](https://docs.u2u.xyz/services/wallets/coinbase-wallet.md)
- [U2U Super App](https://docs.u2u.xyz/services/wallets/u2u-super-app.md)
- [Policy](https://docs.u2u.xyz/services/wallets/u2u-super-app/policy.md)
- [Staking](https://docs.u2u.xyz/services/staking.md)
- [How To Stake?](https://docs.u2u.xyz/services/staking/how-to-stake.md)
- [FAQ](https://docs.u2u.xyz/services/staking/faq.md)
- [The Graph](https://docs.u2u.xyz/services/the-graph.md): Introduction
- [Deploy a Graph Node](https://docs.u2u.xyz/services/the-graph/deploy-a-graph-node.md)
- [Deploy a Subgraph](https://docs.u2u.xyz/services/the-graph/deploy-a-subgraph.md)
- [Bridge](https://docs.u2u.xyz/services/bridge.md)
- [Smart Contracts & EOA](https://docs.u2u.xyz/services/bridge/smart-contracts-and-eoa.md)
- [Oracle](https://docs.u2u.xyz/services/oracle.md)
- [Smart Contracts & EOA](https://docs.u2u.xyz/services/oracle/smart-contracts-and-eoa.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.u2u.xyz/services.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
